Bug 845934 - Review Request: wt - C++ library for developing web applications
Review Request: wt - C++ library for developing web applications
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Robin Lee
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-08-06 03:35 EDT by Michal Minar
Modified: 2012-10-01 15:01 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-09-13 09:39:02 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
robinlee.sysu: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)
Files with different licenses (2.46 KB, text/plain)
2012-08-18 01:35 EDT, Robin Lee
no flags Details
rpmlint output on all the rpm files (34.03 KB, text/plain)
2012-08-18 01:36 EDT, Robin Lee
no flags Details

  None (edit)
Description Michal Minar 2012-08-06 03:35:46 EDT
Spec URL: http://minami.cz/public/witty.spec
SRPM URL: http://minami.cz/public/witty-3.2.1-1.fc16.src.rpm
Description:
Web C++ library with widget oriented API that uses well-tested patterns of
desktop GUI development tailored to the web. To the developer, it offers
abstraction of web-specific implementation details, including client-server
protocols, event handling, graphics support, graceful degradation (or
progressive enhancement), and URL handling.

Fedora Account System Username: miminar
Comment 1 Robin Lee 2012-08-06 05:35:05 EDT
Why name the package witty instead of wt?

There is a maintained wt rpm in Russian Fedora repo: http://pkgs.org/fedora-16/russian-fedora-free-updates-x86_64/wt-3.2.0-1.fc16.R.x86_64.rpm/download/ . You may have a look at it.

The latest version is 3.2.2-p1.
Comment 2 Michal Minar 2012-08-07 03:12:26 EDT
One reason for naming it 'witty' is that ubuntu and and debian does so:
  http://packages.debian.org/source/sid/witty
  https://launchpad.net/ubuntu/+source/witty
Second is that it's subjectively nicer name. Citing its homepage:
  "Wt (pronounced as witty) is a C++ library for developing web applications."
Thank you for pointing on existing rpm, I'll try to contact the mantainer first.
And thank you for checking the version. I was packaging this for some time and somehow I missed this new release.
Comment 3 Michal Minar 2012-08-07 16:09:11 EDT
New spec inspired with rpm mention above:
  Spec URL: http://minami.cz/public/wt.spec
  SRPM URL: http://minami.cz/public/wt-3.2.2p1-1.fc16.src.rpm
Renamed to wt.

Vasiliy N. Glazov (one of maintainers of wt in Russian fedora) is now on vacation, but expressed interest. So let's wait for his feedback when he comes back.
Comment 4 Vasiliy Glazov 2012-08-13 09:41:51 EDT
I return and ready to work.

1. First of all, we must understand name of last sources:
3.2.2-p1	Jul 27, 2012	Wt 3.2.2 patch-level 1

It pre-release or post-release of 3.2.2? Then package name should be
if pre: wt-3.2.2-0.1.p1
if post: wt-3.2.2-2.p1
http://fedoraproject.org/wiki/Packaging:NamingGuidelines#Non-Numeric_Version_in_Release

2. I think subpackages -devel and -examples can be merged. Because all header files should be in devel. And install -examples without -devel does not make sense.
3. Remove all defattr... from %files section.
4. Remove rm -rf $RPM_BUILD_ROOT from %install section.
5. Why you convert absolute symlink to relative? rpmlint warning on it.

Please check all packages (and srpm and spec) with rpmlint tool.
Comment 5 Michal Minar 2012-08-13 10:44:58 EDT
(In reply to comment #4)
> I return and ready to work.
> 
> 1. First of all, we must understand name of last sources:
> 3.2.2-p1	Jul 27, 2012	Wt 3.2.2 patch-level 1
> 
> It pre-release or post-release of 3.2.2? Then package name should be
> if pre: wt-3.2.2-0.1.p1
> if post: wt-3.2.2-2.p1
> http://fedoraproject.org/wiki/Packaging:NamingGuidelines#Non-
> Numeric_Version_in_Release
It's a post-release. On http://sourceforge.net/projects/witty/files/wt/3.2.2/
you can find version 3.2.2, that was uploaded before 3.2.2-p1.
You are right about the version scheme. I've got the naming convention wrong, when reading these guide lines last time. wt-3.2.2-1.p1 should be the correct one.
> 
> 2. I think subpackages -devel and -examples can be merged. Because all
> header files should be in devel. And install -examples without -devel does
> not make sense.
I'm not sure about that. I followed a qt rpm package example, which
bundles both binary examples and their source file into one.
I'd rather not move example source files into devel, since they are not
neccessary to build anything against wt library. Probably better solution would be not to make and -examples pkg, add their source files to -doc package and let the user build them, if he wants to.
> 3. Remove all defattr... from %files section.
> 4. Remove rm -rf $RPM_BUILD_ROOT from %install section.
Ok. Also the %clean section is not neccessary.
> 5. Why you convert absolute symlink to relative? rpmlint warning on it.
Rpmlint complains about both relative and absolute ones. This is one more reason to package the examples into doc without binaries. Because this package can not be rid of rpmlint warnings.
> 
> Please check all packages (and srpm and spec) with rpmlint tool.
Comment 6 Vasiliy Glazov 2012-08-14 01:34:12 EDT
At least you need remove all errors from rpmlint

wt-examples.x86_64: E: non-executable-script /usr/share/wt/resources/themes/default/stripes/generate.sh 0644L /bin/sh
wt-examples.x86_64: E: non-executable-script /usr/share/wt/resources/themes/polished/no-stripes/generate.sh 0644L /bin/sh
wt-examples.x86_64: E: non-executable-script /usr/share/wt/resources/themes/polished/stripes/generate.sh 0644L /bin/sh
wt-examples.x86_64: E: htaccess-file /usr/lib64/Wt/examples/hangman/.htaccess
wt-examples.x86_64: E: non-executable-script /usr/share/wt/resources/themes/default/no-stripes/generate.sh 0644L /bin/sh
wt-examples.x86_64: E: non-executable-script /usr/share/wt/resources/themes/default/stripes/generate.sh 0644L /bin/sh
wt-examples.x86_64: E: non-executable-script /usr/share/wt/resources/themes/polished/no-stripes/generate.sh 0644L /bin/sh
wt-examples.x86_64: E: non-executable-script /usr/share/wt/resources/themes/polished/stripes/generate.sh 0644L /bin/sh
wt-examples.x86_64: E: htaccess-file /usr/lib64/Wt/examples/hangman/.htaccess
wt-examples.x86_64: E: non-executable-script /usr/share/wt/resources/themes/default/no-stripes/generate.sh 0644L /bin/sh
Comment 7 Robin Lee 2012-08-14 09:29:29 EDT
My some initial opinions:

* No explicit require on Boost libraries
* BR cmake
* My suggestion of subpackaging:
  - wt, for the core libraries
  - wt-dbo, for the Dbo libraries, including the Sqlite backend
  - wt-dbo-postgres, for the Postgres backend of Dbo
  - wt-dbo-firebird, for the Firebird backend of Dbo
  - wt-devel
  - wt-examples
  - wt-doc, for all the documents, marked noarch
Comment 8 Vasiliy Glazov 2012-08-14 09:31:57 EDT
Robin, examples directory contain some .h files. Should them be in wt-devel or in wt-examples subpackage?
Comment 9 Robin Lee 2012-08-14 09:41:05 EDT
Absolutely not in wt-devel. qt-examples also contains all the source codes of the examples.
Comment 10 Michal Minar 2012-08-14 12:00:28 EDT
Fixed some issues:
  Spec URL: http://minami.cz/public/wt.spec
  SRPM URL: http://minami.cz/public/wt-3.2.2-1.p1.fc16.src.rpm
* corrected version-release to comply to post-release naming
* added BR cmake
* removed boost libs from Requires
* subpackaging done as Robin suggested
* .htaccess files renamed to htaccess
* removed generate.sh scripts, since they are not required to run anything
Comment 11 Robin Lee 2012-08-18 01:34:31 EDT
Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== C/C++ ====
[x]: MUST Header files in -devel subpackage, if present.
     Note: wt-examples-3.2.2-1.p1.fc16.x86_64.rpm :
     /usr/lib64/Wt/examples/blog/BlogRSSFeed.h wt-
     .....
     (OK. Those are in an package of example programs)

[x]: MUST ldconfig called in %post and %postun if required.
[x]: MUST Package does not contain any libtool archives (.la)
[x]: MUST Package does not contain kernel modules.
[x]: MUST Package contains no static executables.
[x]: MUST Rpath absent or only used for internal libs.
[x]: MUST Development (unversioned) .so files in -devel subpackage, if
     present.


==== Generic ====
[x]: EXTRA Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: EXTRA Spec file according to URL is the same as in SRPM.
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Unless packager wants to package for EPEL5 this is fine
[!]: MUST Package contains no bundled libraries.
     Note: Please set cmake macro USE_SYSTEM_SQLITE3 to use system sqlite

[x]: MUST Changelog in prescribed format.
[x]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL is required
[x]: MUST Sources contain only permissible code or content.
[x]: MUST %config files are marked noreplace or the reason is justified.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[?]: MUST Package contains desktop file if it is a GUI application.
[x]: MUST Development files must be in a -devel package
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Fully versioned dependency in subpackages, if present.
[x]: MUST Package complies to the Packaging Guidelines
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf would be needed if support for EPEL5 is required
[x]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[!]: MUST License field in the package spec file matches the actual license.
     Note: Please check the attachment 'licensecheck-different.txt' for files with a different license.

[x]: MUST License file installed when any subpackage combination is installed.
[x]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: MUST Package is named using only allowed ascii characters.
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST No %config files under /usr.
[x]: MUST Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[!]: MUST Package must own all directories that it creates.
     The following directories not owned:
     %{_datadir}/wt/
     %{_datadir}/wt/resources/

[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Package is not relocatable.
[!]: MUST Requires correct, justified where necessary.
     Note: wt-dbo does not require wt. And so keep a copy of license in wt-dbo.

[x]: MUST Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[?]: MUST Package contains systemd file(s) if in need.
[x]: MUST File names are valid UTF-8.
[?]: MUST Useful -debuginfo package or justification otherwise.
[x]: SHOULD Reviewer should test that the package builds in mock.
[x]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: SHOULD Package functions as described.
[x]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD Scriptlets must be sane, if used.
[x]: SHOULD SourceX / PatchY prefixed with %{name}.
[x]: SHOULD SourceX is a working URL.
[x]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[x]: SHOULD %check is present and all tests pass.
     Note: test requires Internet connection.
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.

Issues:
[!]: MUST Package contains no bundled libraries.
     Note: Please set cmake macro USE_SYSTEM_SQLITE3 to use system sqlite
[!]: MUST License field in the package spec file matches the actual license.
     Note: Please check the attachment 'licensecheck-different.txt' for files with a different license.
[!]: MUST Package must own all directories that it creates.
     The following directories not owned:
     %{_datadir}/wt/
     %{_datadir}/wt/resources/
     /var/spool/wt
     /var/spool/wt/run
     %{_includedir}/Wt/
     %{_defaultdocdir}/%{name}-%{version}/images/
     %{_defaultdocdir}/%{name}-%{version}/reference/
     %{_defaultdocdir}/%{name}-%{version}/tutorial/
     %{_defaultdocdir}/%{name}-%{version}/examples/
[!]: MUST Requires correct, justified where necessary.
     Note:
     * wt-dbo does not require wt. And so keep a copy of license in wt-dbo.
     * wt-devel should require wt-dbo-firebird

Other personal checks:
[!]: Is that necessary to rename %{_datadir}/Wt/ to %{_datadir}/wt/ ?
[!]: %{_defaultdocdir}/%{name}-%{version}/main is a junk.
[!]: Summary and description texts may be revised. My suggestions:
     * Summary for dbo: Wt::Dbo ORM library and the Sqlite backend
     * Desc for dbo:
      This package contains the Wt::Dbo Object-Relational Mapping library
      and the Sqlite3 backend of it.

     * Summary for dbo-postgres : PostgresSQL backend for the Wt::Dbo ORM library
     * Desc for dbo-postgres: This package contains the PostgresSQL backend for the Wt::Dbo ORM library

     * Summary for devel : 'Development files for Wt and Wt::Dbo' 
     * Desc for devel: This package contains the files necessary to develop
             applications using the Wt toolkit and the Wt::Dbo ORM library.

     * Summary for examples may be just 'Examples for Wt'.
     * Desc for examples may be 'This package contains programming examples distributeed with official Wt release.'

     * Summary for doc may be 'Documents for the Wt toolkit'
     * Desc for doc may be 'This package contains the documents for Wt API and examples.'

Requires
--------
wt-devel-3.2.2-1.p1.fc16.x86_64.rpm (rpmlib, GLIBC filtered):
    
    libwt.so.33()(64bit)  
    libwtdbo.so.33()(64bit)  
    libwtdbofirebird.so.33()(64bit)  
    libwtdbopostgres.so.33()(64bit)  
    libwtdbosqlite3.so.33()(64bit)  
    libwtext.so.33()(64bit)  
    libwtfcgi.so.33()(64bit)  
    libwthttp.so.33()(64bit)  
    libwttest.so.3()(64bit)  
    wt(x86-64) = 3.2.2-1.p1.fc16
    wt-dbo(x86-64) = 3.2.2-1.p1.fc16
    wt-dbo-postgres(x86-64) = 3.2.2-1.p1.fc16

wt-debuginfo-3.2.2-1.p1.fc16.x86_64.rpm (rpmlib, GLIBC filtered):
    

wt-dbo-3.2.2-1.p1.fc16.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /sbin/ldconfig  
    libboost_date_time-mt.so.1.47.0()(64bit)  
    libboost_system-mt.so.1.47.0()(64bit)  
    libboost_thread-mt.so.1.47.0()(64bit)  
    libc.so.6()(64bit)  
    libdl.so.2()(64bit)  
    libgcc_s.so.1()(64bit)  
    libgcc_s.so.1(GCC_3.0)(64bit)  
    libm.so.6()(64bit)  
    libpthread.so.0()(64bit)  
    libstdc++.so.6()(64bit)  
    libstdc++.so.6(CXXABI_1.3)(64bit)  
    libwtdbo.so.33()(64bit)  
    rtld(GNU_HASH)  
    wt(x86-64) = 3.2.2-1.p1.fc16

wt-doc-3.2.2-1.p1.fc16.noarch.rpm (rpmlib, GLIBC filtered):
    

wt-dbo-postgres-3.2.2-1.p1.fc16.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /sbin/ldconfig  
    libboost_date_time-mt.so.1.47.0()(64bit)  
    libboost_system-mt.so.1.47.0()(64bit)  
    libboost_thread-mt.so.1.47.0()(64bit)  
    libc.so.6()(64bit)  
    libgcc_s.so.1()(64bit)  
    libgcc_s.so.1(GCC_3.0)(64bit)  
    libm.so.6()(64bit)  
    libpq.so.5()(64bit)  
    libpthread.so.0()(64bit)  
    libstdc++.so.6()(64bit)  
    libstdc++.so.6(CXXABI_1.3)(64bit)  
    libstdc++.so.6(CXXABI_1.3.1)(64bit)  
    libwtdbo.so.33()(64bit)  
    rtld(GNU_HASH)  
    wt(x86-64) = 3.2.2-1.p1.fc16
    wt-dbo(x86-64) = 3.2.2-1.p1.fc16

wt-dbo-firebird-3.2.2-1.p1.fc16.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /sbin/ldconfig  
    libboost_date_time-mt.so.1.47.0()(64bit)  
    libboost_system-mt.so.1.47.0()(64bit)  
    libboost_thread-mt.so.1.47.0()(64bit)  
    libc.so.6()(64bit)  
    libfbclient.so.2()(64bit)  
    libgcc_s.so.1()(64bit)  
    libgcc_s.so.1(GCC_3.0)(64bit)  
    libm.so.6()(64bit)  
    libpthread.so.0()(64bit)  
    libstdc++.so.6()(64bit)  
    libstdc++.so.6(CXXABI_1.3)(64bit)  
    libwtdbo.so.33()(64bit)  
    rtld(GNU_HASH)  
    wt(x86-64) = 3.2.2-1.p1.fc16
    wt-dbo(x86-64) = 3.2.2-1.p1.fc16

wt-examples-3.2.2-1.p1.fc16.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /bin/bash  
    libGraphicsMagick.so.3()(64bit)  
    libQtCore.so.4()(64bit)  
    libQtGui.so.4()(64bit)  
    libboost_date_time-mt.so.1.47.0()(64bit)  
    libboost_filesystem-mt.so.1.47.0()(64bit)  
    libboost_program_options-mt.so.1.47.0()(64bit)  
    libboost_random-mt.so.1.47.0()(64bit)  
    libboost_regex-mt.so.1.47.0()(64bit)  
    libboost_signals-mt.so.1.47.0()(64bit)  
    libboost_system-mt.so.1.47.0()(64bit)  
    libboost_thread-mt.so.1.47.0()(64bit)  
    libc.so.6()(64bit)  
    libcrypt.so.1()(64bit)  
    libcrypto.so.10()(64bit)  
    libdl.so.2()(64bit)  
    libgcc_s.so.1()(64bit)  
    libgcc_s.so.1(GCC_3.0)(64bit)  
    libglib-2.0.so.0()(64bit)  
    libgobject-2.0.so.0()(64bit)  
    libhpdf-2.1.0.so()(64bit)  
    libm.so.6()(64bit)  
    libpango-1.0.so.0()(64bit)  
    libpangoft2-1.0.so.0()(64bit)  
    libpng12.so.0()(64bit)  
    libpthread.so.0()(64bit)  
    libssl.so.10()(64bit)  
    libstdc++.so.6()(64bit)  
    libstdc++.so.6(CXXABI_1.3)(64bit)  
    libstdc++.so.6(CXXABI_1.3.1)(64bit)  
    libwt.so.33()(64bit)  
    libwtdbo.so.33()(64bit)  
    libwtdbosqlite3.so.33()(64bit)  
    libwtext.so.33()(64bit)  
    libwthttp.so.33()(64bit)  
    libz.so.1()(64bit)  
    rtld(GNU_HASH)  
    wt(x86-64) = 3.2.2-1.p1.fc16
    wt-dbo(x86-64) = 3.2.2-1.p1.fc16

wt-3.2.2-1.p1.fc16.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /sbin/ldconfig  
    config(wt) = 3.2.2-1.p1.fc16
    libGraphicsMagick.so.3()(64bit)  
    libboost_date_time-mt.so.1.47.0()(64bit)  
    libboost_filesystem-mt.so.1.47.0()(64bit)  
    libboost_program_options-mt.so.1.47.0()(64bit)  
    libboost_random-mt.so.1.47.0()(64bit)  
    libboost_regex-mt.so.1.47.0()(64bit)  
    libboost_signals-mt.so.1.47.0()(64bit)  
    libboost_system-mt.so.1.47.0()(64bit)  
    libboost_thread-mt.so.1.47.0()(64bit)  
    libc.so.6()(64bit)  
    libcrypto.so.10()(64bit)  
    libfcgi++.so.0()(64bit)  
    libfcgi.so.0()(64bit)  
    libgcc_s.so.1()(64bit)  
    libgcc_s.so.1(GCC_3.0)(64bit)  
    libglib-2.0.so.0()(64bit)  
    libgobject-2.0.so.0()(64bit)  
    libhpdf-2.1.0.so()(64bit)  
    libm.so.6()(64bit)  
    libpango-1.0.so.0()(64bit)  
    libpangoft2-1.0.so.0()(64bit)  
    libpng12.so.0()(64bit)  
    libpthread.so.0()(64bit)  
    libssl.so.10()(64bit)  
    libstdc++.so.6()(64bit)  
    libstdc++.so.6(CXXABI_1.3)(64bit)  
    libstdc++.so.6(CXXABI_1.3.1)(64bit)  
    libwt.so.33()(64bit)  
    libz.so.1()(64bit)  
    rtld(GNU_HASH)  

Provides
--------
wt-devel-3.2.2-1.p1.fc16.x86_64.rpm:
    
    wt-devel = 3.2.2-1.p1.fc16
    wt-devel(x86-64) = 3.2.2-1.p1.fc16

wt-debuginfo-3.2.2-1.p1.fc16.x86_64.rpm:
    
    wt-debuginfo = 3.2.2-1.p1.fc16
    wt-debuginfo(x86-64) = 3.2.2-1.p1.fc16

wt-dbo-3.2.2-1.p1.fc16.x86_64.rpm:
    
    libwtdbo.so.33()(64bit)  
    libwtdbosqlite3.so.33()(64bit)  
    wt-dbo = 3.2.2-1.p1.fc16
    wt-dbo(x86-64) = 3.2.2-1.p1.fc16

wt-doc-3.2.2-1.p1.fc16.noarch.rpm:
    
    wt-doc = 3.2.2-1.p1.fc16

wt-dbo-postgres-3.2.2-1.p1.fc16.x86_64.rpm:
    
    libwtdbopostgres.so.33()(64bit)  
    wt-dbo-postgres = 3.2.2-1.p1.fc16
    wt-dbo-postgres(x86-64) = 3.2.2-1.p1.fc16

wt-dbo-firebird-3.2.2-1.p1.fc16.x86_64.rpm:
    
    libwtdbofirebird.so.33()(64bit)  
    wt-dbo-firebird = 3.2.2-1.p1.fc16
    wt-dbo-firebird(x86-64) = 3.2.2-1.p1.fc16

wt-examples-3.2.2-1.p1.fc16.x86_64.rpm:
    
    wt-examples = 3.2.2-1.p1.fc16
    wt-examples(x86-64) = 3.2.2-1.p1.fc16

wt-3.2.2-1.p1.fc16.x86_64.rpm:
    
    config(wt) = 3.2.2-1.p1.fc16
    libwt.so.33()(64bit)  
    libwtext.so.33()(64bit)  
    libwtfcgi.so.33()(64bit)  
    libwthttp.so.33()(64bit)  
    libwttest.so.3()(64bit)  
    wt = 3.2.2-1.p1.fc16
    wt(x86-64) = 3.2.2-1.p1.fc16

MD5-sum check
-------------
http://citylan.dl.sourceforge.net/project/witty/wt/3.2.2/wt-3.2.2-p1.tar.gz :
  MD5SUM this package     : d436430a4f1ae5fbcf038e645e4b5260
  MD5SUM upstream package : d436430a4f1ae5fbcf038e645e4b5260
  SHA256SUM this package  :
  1610b1950eda3614a12e915f5968d7b8659eb17231622681c9a1eafc586c8f05
  SHA256SUM upstream package:
  1610b1950eda3614a12e915f5968d7b8659eb17231622681c9a1eafc586c8f05



Generated by fedora-review 0.2.0 (53cc903) last change: 2012-07-09
Command line :/usr/bin/fedora-review -c --no-build -b 845934
External plugins:
Comment 12 Robin Lee 2012-08-18 01:35:38 EDT
Created attachment 605305 [details]
Files with different licenses
Comment 13 Robin Lee 2012-08-18 01:36:35 EDT
Created attachment 605306 [details]
rpmlint output on all the rpm files
Comment 14 Robin Lee 2012-08-18 01:39:42 EDT
A typo found in my review. The line should be:

* Desc for examples may be 'This package contains programming examples distributed with official Wt release.'
Comment 15 Robin Lee 2012-08-18 09:12:52 EDT
The -doc subpackage should require -devel.
Comment 16 Robin Lee 2012-08-18 09:49:22 EDT
It may be better to use absolute path for the links in -examples subpackage. Since example may generate a Sqlite db file in the same directory, but the directory is not writable for normal user, he/she may have to copy the whole directory to another place and then the example run properly. But then relative symlink will break.
Comment 17 Michal Minar 2012-08-21 07:47:39 EDT
Thank you Robin for thorough examination.
Can you please explain, why there is a need for -doc package to require -devel?
I've got an rpmlint error concerning this.

There is also a licensing problem. Witty bundles IBPP library (htpp://www.ibpp.org) under IBPP license. Unfortunately, this license is not known to Fedora, so I contacted legal-list; this influences just the Firebird backend.

Good point with copying the examples.
Comment 18 Robin Lee 2012-08-21 22:13:27 EDT
(In reply to comment #17)
> Thank you Robin for thorough examination.
> Can you please explain, why there is a need for -doc package to require
> -devel?
> I've got an rpmlint error concerning this.
OK, that's my fault.
Comment 19 Michal Minar 2012-08-22 04:29:25 EDT
I tried to fix all errors, the result is here:
  Spec URL: http://minami.cz/public/wt.spec
  SRPM URL: http://minami.cz/public/wt-3.2.2-1.p1.fc16.src.rpm
Summary changes:
 * corrected licensing
   - added PACKAGE-LICENSING file to docs
   - there is a bundled library (IBPP: htpp://www.ibpp.org) under IBPP license
     unfortunately, this license is not known to Fedora, so I contacted
     legal-list; this influences just the Firebird backend
 * packages own directories they create
 * using system sqlite library
 * fixed requires for -dbo, -postgres, -firebird
   - also added sqlite-devel as BR
 * renamed /usr/share/wt to /usr/share/Wt (which is default for witty)
 * removed %{_defaultdocdir}/%{name}-%{version}/main
 * symlinks to /usr/share/Wt/resources now absolute
   - good point with copying
 * rewritten summaries and descriptions
I'm afraid, we'll need to wait for clarification regarding IBPP.
Comment 20 Robin Lee 2012-08-22 09:26:15 EDT
We should try our best to remove any bundled library, so maybe you can submit a new request for ibpp, and make it as blocker of this one.
Comment 21 Robin Lee 2012-08-22 09:27:35 EDT
Any usually it is recommended to bump release number even under review progress.
Comment 22 Robin Lee 2012-08-22 09:29:05 EDT
And usually it is recommended to bump release number even under review progress.
Comment 23 Michal Minar 2012-08-24 04:01:05 EDT
Ok, I'll make a new package of it. Unfortunately Red Hat Legal founds their license Non-Free. I've asked them to consider relicensing under MIT.
Comment 24 Robin Lee 2012-08-24 04:48:55 EDT
Relicensing request is usually rude for upstream. Maybe at first you can exclude the Firebird backend and we can go ahead with Wt.
Comment 25 Michal Minar 2012-08-24 07:23:53 EDT
Not packaging firebird backend:
  Spec URL: http://minami.cz/public/wt.spec
  SRPM URL: http://minami.cz/public/wt-3.2.2-2.p1.fc16.src.rpm
Comment 26 Robin Lee 2012-08-24 07:58:32 EDT
* %{_libdir}/Wt/examples/ is not owned.
* wt-doc subpackage should include a copy of LICENSE, since it doesn't require the base package.
* wt-examples subpackage may use a special License tag if some of the examples generated from sources with special licenses.
Comment 27 Michal Minar 2012-08-24 09:50:03 EDT
Fixed:
  Spec URL: http://minami.cz/public/wt.spec
  SRPM URL: http://minami.cz/public/wt-3.2.2-3.p1.fc16.src.rpm
Comment 28 Robin Lee 2012-08-24 10:08:40 EDT
LICENSE would be included in three packages. That's conflicting and will leave the %{_defaultdocdir}/%{name}-%{version}/ directory unowned if wt is not installed. There are two solutions:

1. Let wt-dbo and wt-doc have their own doc dir. For wt-doc that is %{_docdir}/%{name}-doc-%{version}/, so wt-dbo and wt-doc can include their own true copies of license.

2. Let wt-doc require wt. But it's not acceptable if wt-dbo requires wt.
Comment 29 Robin Lee 2012-08-24 10:10:37 EDT
And ReleaseNotes.html with the same path is included in wt and wt-doc, that's not allowed.
Comment 30 Michal Minar 2012-09-03 06:07:30 EDT
Fixed:
  Spec URL: http://minami.cz/public/wt.spec
  SRPM URL: http://minami.cz/public/wt-3.2.2-4.p1.fc16.src.rpm

IBPP team is considering relicensing.
Comment 31 Robin Lee 2012-09-11 22:01:53 EDT
Since the IBPP library is not considered non-free, you may need to reproduce the tarball flowing http://fedoraproject.org/wiki/Packaging:SourceURL#When_Upstream_uses_Prohibited_Code

wt-devel installs a file to %{_datadir}/cmake/Modules/, so it should require cmake.
Comment 32 Michal Minar 2012-09-12 06:52:43 EDT
Fixed:
  Spec URL: http://minami.cz/public/wt.spec
  SRPM URL: http://minami.cz/public/wt-3.2.2-5.p1.fc16.src.rpm

* added requires on cmake for -devel
* removed IBPP library from source with bundled wt-generate-tarball.sh script
Comment 33 Robin Lee 2012-09-12 07:15:54 EDT
Approved by cheeselee
Comment 34 Michal Minar 2012-09-12 08:09:10 EDT
Thank you Robin for your patience, reminders and care.
I've learned a lot during this review.
Comment 35 Michal Minar 2012-09-12 08:15:09 EDT
New Package SCM Request
=======================
Package Name: wt
Short Description: C++ library for developing web applications
Owners: miminar
Branches: f16 f17 f18 el6
InitialCC:
Comment 36 Robin Lee 2012-09-12 21:42:08 EDT
fedora-cvs should be set to '?' instead of '+'.
Comment 37 Gwyn Ciesla 2012-09-13 07:24:26 EDT
Git done (by process-git-requests).
Comment 38 Fedora Update System 2012-09-13 09:23:25 EDT
wt-3.2.2-6.p1.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/wt-3.2.2-6.p1.fc16
Comment 39 Fedora Update System 2012-09-13 09:31:41 EDT
wt-3.2.2-6.p1.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/wt-3.2.2-6.p1.fc17
Comment 40 Fedora Update System 2012-09-13 09:35:44 EDT
wt-3.2.2-6.p1.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/wt-3.2.2-6.p1.fc18
Comment 41 Fedora Update System 2012-09-14 05:43:39 EDT
wt-3.2.2-6.p1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/wt-3.2.2-6.p1.el6
Comment 42 Fedora Update System 2012-09-26 04:58:11 EDT
wt-3.2.2-6.p1.fc16 has been pushed to the Fedora 16 stable repository.
Comment 43 Fedora Update System 2012-09-26 05:14:47 EDT
wt-3.2.2-6.p1.fc17 has been pushed to the Fedora 17 stable repository.
Comment 44 Fedora Update System 2012-10-01 15:01:24 EDT
wt-3.2.2-6.p1.el6 has been pushed to the Fedora EPEL 6 stable repository.

Note You need to log in before you can comment on or make changes to this bug.